• 0 Posts
  • 13 Comments
Joined 1 year ago
cake
Cake day: June 25th, 2023

help-circle


  • Unfortunately both of those are used in common English or computer words. The only letter pairs not used are: bq, bx, cf, cj, dx, fq, fx, fz, hx, jb, jc, jf, jg, jq, jv, jx, jz, kq, kz, mx, px, qc, qd, qg, qh, qj, qk, ql, qm, qn, qp, qq, qr, qt, qv, qx, qy, qz, sx, tx, vb, vc, vf, vj, vm, vq, vw, vx, wq, wx, xj, zx.

    Personally I have mappings based on <CR>, and press it twice to get a real newline.



  • Speed is far from the only thing that matters in terminal emulators though. Correctness is critical.

    The only terminals in which I have any confidence of correctness are xterm and pangoterm. And I suppose technically the BEL-for-ST extension is incorrect even there, but we have to live with that and a workaround is available.

    A lot of terminal emulators end up hard-coding a handful of common sequences, and fail to correctly ignore sequences they don’t implement. And worse, many go on to implement sequences that cannot be correctly handled.

    One simple example that usually fails: \e!!F. More nasty, however, are the ones that ignore intermediaries and execute some unrelated command instead.

    I can’t be bothered to pick apart specific terminals anymore. Most don’t even know what an IR is.




  • Two of the most expensive things a shell does are call fork and call execve for an external program. pwd is a builtin (at least for bash) but the former still applies. $PWD exists even if you don’t want that shortening; just like your backticks be sure to quote it once so it doesn’t get expanded when assigning to PS1.

    In general, for most things you might want to do, you can arrange for variables to be set ahead of time and simply expanded at use time, rather than recalculating them every time. For example, you can hook cd/pushd/popd to get an actually-fast git prompt. Rather than var=$(some_function) you should have some_function output directly to a variable (possibly hard-coded - REPLY is semi-common; you can move the value later); printf -v is often useful. Indirection should almost always be avoided (unless you do the indirect-unset bash-specific hack or don’t have any locals) due to shadowing problems (you have to hard-code variable name assumptions anyway so you might as well be explicit).


  • That doesn’t seem sensible. Moving the cursor will confuse bash and you can get the same effect by just omitting the last \n.

    Note that bash 5.0, but not earlier or later versions, is buggy with multiline prompts even if they’re correct.

    Your colors should use 39 (or 49) for reset.

    Avoid doing external commands in subshells when there’s a perfectly good prompt-expansion string that works.

    You seem to be generating several unnecessary blank lines, though I haven’t analyzed them in depth; remember that doing them conditionally is an option, like I do:

    #PS1 built up incrementally before this, including things like setting TTY title for appropriate terminals
    PS0='vvv \D{%F %T%z}\n'
    PS1='^^^ \D{%F %T%z}\n'"$PS1"
    prompt-command-exit-nonzero()
    {
        # TODO map signal names and <sysexits.h> and 126/127 errors?
        # (128 also appears in some weird job-control cases; there are also
        # numerous cases where $? is not in $PIPESTATUS)
        # This has to come first since $? will be invalidated.
        # It's also one of the few cases where `*` is non-buggy for an array.
        local e=$? pipestatus="${PIPESTATUS[*]}"
        # Fixup newline. Note that interactive shells specifically use stderr
        # for the prompt, not stdin, stdout, or /dev/tty
        printf '\e[93;41m%%\e[39;49m%'"$((COLUMNS-1))"'s\r' >&2
        # if e or any pipestatus is nonzero
        if [[ -n "${e/0}${pipestatus//[ 0]}" ]]
        then
            if [[ "$pipestatus" != "$e" ]]
            then
                local pipestatus_no_SIGPIPE="${pipestatus//141 /}"
                local color=41
                if [[ -z "${pipestatus_no_SIGPIPE//[ 0]}" ]]
                then
                    color=43
                fi
                printf '\e[%smexit_status: %s (%s)\e[49m\n' "$color" "$e" "${pipestatus// / | }" >&2
            else
                printf '\e[41mexit_status: %s\e[49m\n' "$e" >&2
            fi
        fi
    }
    PROMPT_COMMAND='prompt-command-exit-nonzero'
    
    

  • The problem with IDEs is that they are less than the sum of their parts.

    There are no old Emacs users on the internet because their fingers are no longer capable of typing. Unfortunately, most other text editors use keybindings reminscent of emacs.

    Neovim doesn’t offer much value over classic vim, and is much more prone to being outdated on some random system you might use.

    Don’t put too much in your .vimrc, since then you’ll have trouble when you move to another computer. I can survive with just 3 lines in my .vimrc (easy to memorize), with a 4th likely:

    " because I hate default <Esc> location and behavior
    set virtualedit=onemore
    nnoremap <CR> i<CR>
    inoremap <CR> <C-O>:stopinsert<CR>
    " If you press it fast enough, don't break undo.
    inoremap <CR><CR> <CR>
    

    That’s not all I end up with if I use vim extensively on a single system, but the other stuff can be added as I get bothered (line numbering, tab behavior, TTY title, backups, undos, modeline, mouse, search, wrapping)

    (admittedly I don’t bother with LSP integration; if you rely on that you probably need more)


  • o11c@programming.devtoProgrammer Humor@programming.devBorrow Checker
    link
    fedilink
    English
    arrow-up
    6
    arrow-down
    2
    ·
    1 year ago

    What you are missing, of course, is the Rc<Refcell<T>> that you have to stick everywhere to make a nontrivial Rust program. It’s like monads in Haskell, parentheses in lisp, verbosity in Java, or warnings in C - they’re the magic words you have to incant correctly to make things work in their weird paradigms.


  • o11c@programming.devtoExperienced Devs@programming.devIs Java not good?
    link
    fedilink
    English
    arrow-up
    0
    arrow-down
    1
    ·
    1 year ago

    Java lacks value types, so it can only be fast if you avoid classes and (pretty much) only use primitives. Some other JVM languages implement them hackily, but C# / .NET does this properly.

    Valhalla has been calling for a decade, but the warriors must not be worthy, and looking at their demo stuff I don’t think they understand what they’re doing with the restrictions they’re specifying.